// SCSS variables are information about icon's compiled state, stored under its original file name
//
// .icon-home {
//   width: $icon-home-width;
// }
//
// The large array-like variables contain all information about a single icon
// $icon-home: x y offset_x offset_y width height total_width total_height image_path;
//
// At the bottom of this section, we provide information about the spritesheet itself
// $spritesheet: width height image $spritesheet-sprites;
$icon-s1-name: 'icon-s1';
$icon-s1-x: 0px;
$icon-s1-y: 0px;
$icon-s1-offset-x: 0px;
$icon-s1-offset-y: 0px;
$icon-s1-width: 31px;
$icon-s1-height: 31px;
$icon-s1-total-width: 31px;
$icon-s1-total-height: 686px;
$icon-s1-image: 'sprite.png';
$icon-s1: (0px, 0px, 0px, 0px, 31px, 31px, 31px, 686px, 'sprite.png', 'icon-s1', );
$icon-s2-name: 'icon-s2';
$icon-s2-x: 0px;
$icon-s2-y: 131px;
$icon-s2-offset-x: 0px;
$icon-s2-offset-y: -131px;
$icon-s2-width: 31px;
$icon-s2-height: 31px;
$icon-s2-total-width: 31px;
$icon-s2-total-height: 686px;
$icon-s2-image: 'sprite.png';
$icon-s2: (0px, 131px, 0px, -131px, 31px, 31px, 31px, 686px, 'sprite.png', 'icon-s2', );
$icon-s3-name: 'icon-s3';
$icon-s3-x: 0px;
$icon-s3-y: 262px;
$icon-s3-offset-x: 0px;
$icon-s3-offset-y: -262px;
$icon-s3-width: 31px;
$icon-s3-height: 31px;
$icon-s3-total-width: 31px;
$icon-s3-total-height: 686px;
$icon-s3-image: 'sprite.png';
$icon-s3: (0px, 262px, 0px, -262px, 31px, 31px, 31px, 686px, 'sprite.png', 'icon-s3', );
$icon-s4-name: 'icon-s4';
$icon-s4-x: 0px;
$icon-s4-y: 393px;
$icon-s4-offset-x: 0px;
$icon-s4-offset-y: -393px;
$icon-s4-width: 31px;
$icon-s4-height: 31px;
$icon-s4-total-width: 31px;
$icon-s4-total-height: 686px;
$icon-s4-image: 'sprite.png';
$icon-s4: (0px, 393px, 0px, -393px, 31px, 31px, 31px, 686px, 'sprite.png', 'icon-s4', );
$icon-s5-name: 'icon-s5';
$icon-s5-x: 0px;
$icon-s5-y: 524px;
$icon-s5-offset-x: 0px;
$icon-s5-offset-y: -524px;
$icon-s5-width: 31px;
$icon-s5-height: 31px;
$icon-s5-total-width: 31px;
$icon-s5-total-height: 686px;
$icon-s5-image: 'sprite.png';
$icon-s5: (0px, 524px, 0px, -524px, 31px, 31px, 31px, 686px, 'sprite.png', 'icon-s5', );
$icon-s6-name: 'icon-s6';
$icon-s6-x: 0px;
$icon-s6-y: 655px;
$icon-s6-offset-x: 0px;
$icon-s6-offset-y: -655px;
$icon-s6-width: 31px;
$icon-s6-height: 31px;
$icon-s6-total-width: 31px;
$icon-s6-total-height: 686px;
$icon-s6-image: 'sprite.png';
$icon-s6: (0px, 655px, 0px, -655px, 31px, 31px, 31px, 686px, 'sprite.png', 'icon-s6', );
$icon-s1-2x-name: 'icon-s1@2x';
$icon-s1-2x-x: 0px;
$icon-s1-2x-y: 0px;
$icon-s1-2x-offset-x: 0px;
$icon-s1-2x-offset-y: 0px;
$icon-s1-2x-width: 62px;
$icon-s1-2x-height: 62px;
$icon-s1-2x-total-width: 62px;
$icon-s1-2x-total-height: 1372px;
$icon-s1-2x-image: 'sprite@2x.png';
$icon-s1-2x: (0px, 0px, 0px, 0px, 62px, 62px, 62px, 1372px, 'sprite@2x.png', 'icon-s1@2x', );
$icon-s2-2x-name: 'icon-s2@2x';
$icon-s2-2x-x: 0px;
$icon-s2-2x-y: 262px;
$icon-s2-2x-offset-x: 0px;
$icon-s2-2x-offset-y: -262px;
$icon-s2-2x-width: 62px;
$icon-s2-2x-height: 62px;
$icon-s2-2x-total-width: 62px;
$icon-s2-2x-total-height: 1372px;
$icon-s2-2x-image: 'sprite@2x.png';
$icon-s2-2x: (0px, 262px, 0px, -262px, 62px, 62px, 62px, 1372px, 'sprite@2x.png', 'icon-s2@2x', );
$icon-s3-2x-name: 'icon-s3@2x';
$icon-s3-2x-x: 0px;
$icon-s3-2x-y: 524px;
$icon-s3-2x-offset-x: 0px;
$icon-s3-2x-offset-y: -524px;
$icon-s3-2x-width: 62px;
$icon-s3-2x-height: 62px;
$icon-s3-2x-total-width: 62px;
$icon-s3-2x-total-height: 1372px;
$icon-s3-2x-image: 'sprite@2x.png';
$icon-s3-2x: (0px, 524px, 0px, -524px, 62px, 62px, 62px, 1372px, 'sprite@2x.png', 'icon-s3@2x', );
$icon-s4-2x-name: 'icon-s4@2x';
$icon-s4-2x-x: 0px;
$icon-s4-2x-y: 786px;
$icon-s4-2x-offset-x: 0px;
$icon-s4-2x-offset-y: -786px;
$icon-s4-2x-width: 62px;
$icon-s4-2x-height: 62px;
$icon-s4-2x-total-width: 62px;
$icon-s4-2x-total-height: 1372px;
$icon-s4-2x-image: 'sprite@2x.png';
$icon-s4-2x: (0px, 786px, 0px, -786px, 62px, 62px, 62px, 1372px, 'sprite@2x.png', 'icon-s4@2x', );
$icon-s5-2x-name: 'icon-s5@2x';
$icon-s5-2x-x: 0px;
$icon-s5-2x-y: 1048px;
$icon-s5-2x-offset-x: 0px;
$icon-s5-2x-offset-y: -1048px;
$icon-s5-2x-width: 62px;
$icon-s5-2x-height: 62px;
$icon-s5-2x-total-width: 62px;
$icon-s5-2x-total-height: 1372px;
$icon-s5-2x-image: 'sprite@2x.png';
$icon-s5-2x: (0px, 1048px, 0px, -1048px, 62px, 62px, 62px, 1372px, 'sprite@2x.png', 'icon-s5@2x', );
$icon-s6-2x-name: 'icon-s6@2x';
$icon-s6-2x-x: 0px;
$icon-s6-2x-y: 1310px;
$icon-s6-2x-offset-x: 0px;
$icon-s6-2x-offset-y: -1310px;
$icon-s6-2x-width: 62px;
$icon-s6-2x-height: 62px;
$icon-s6-2x-total-width: 62px;
$icon-s6-2x-total-height: 1372px;
$icon-s6-2x-image: 'sprite@2x.png';
$icon-s6-2x: (0px, 1310px, 0px, -1310px, 62px, 62px, 62px, 1372px, 'sprite@2x.png', 'icon-s6@2x', );
$spritesheet-width: 31px;
$spritesheet-height: 686px;
$spritesheet-image: 'sprite.png';
$spritesheet-sprites: ($icon-s1, $icon-s2, $icon-s3, $icon-s4, $icon-s5, $icon-s6, );
$spritesheet: (31px, 686px, 'sprite.png', $spritesheet-sprites, );
$retina-spritesheet-width: 62px;
$retina-spritesheet-height: 1372px;
$retina-spritesheet-image: 'sprite@2x.png';
$retina-spritesheet-sprites: ($icon-s1-2x, $icon-s2-2x, $icon-s3-2x, $icon-s4-2x, $icon-s5-2x, $icon-s6-2x, );
$retina-spritesheet: (62px, 1372px, 'sprite@2x.png', $retina-spritesheet-sprites, );

// These "retina group" variables are mappings for the naming and pairing of normal and retina sprites.
//
// The list formatted variables are intended for mixins like `retina-sprite` and `retina-sprites`.
$icon-s1-group-name: 'icon-s1';
$icon-s1-group: ('icon-s1', $icon-s1, $icon-s1-2x, );
$icon-s2-group-name: 'icon-s2';
$icon-s2-group: ('icon-s2', $icon-s2, $icon-s2-2x, );
$icon-s3-group-name: 'icon-s3';
$icon-s3-group: ('icon-s3', $icon-s3, $icon-s3-2x, );
$icon-s4-group-name: 'icon-s4';
$icon-s4-group: ('icon-s4', $icon-s4, $icon-s4-2x, );
$icon-s5-group-name: 'icon-s5';
$icon-s5-group: ('icon-s5', $icon-s5, $icon-s5-2x, );
$icon-s6-group-name: 'icon-s6';
$icon-s6-group: ('icon-s6', $icon-s6, $icon-s6-2x, );
$retina-groups: ($icon-s1-group, $icon-s2-group, $icon-s3-group, $icon-s4-group, $icon-s5-group, $icon-s6-group, );

// The provided mixins are intended to be used with the array-like variables
//
// .icon-home {
//   @include sprite-width($icon-home);
// }
//
// .icon-email {
//   @include sprite($icon-email);
// }
//
// Example usage in HTML:
//
// `display: block` sprite:
// <div class="icon-home"></div>
//
// To change `display` (e.g. `display: inline-block;`), we suggest using a common CSS class:
//
// // CSS
// .icon {
//   display: inline-block;
// }
//
// // HTML
// <i class="icon icon-home"></i>
@mixin sprite-width($sprite) {
  width: nth($sprite, 5);
}

@mixin sprite-height($sprite) {
  height: nth($sprite, 6);
}

@mixin sprite-position($sprite) {
  $sprite-offset-x: nth($sprite, 3);
  $sprite-offset-y: nth($sprite, 4);
  background-position: $sprite-offset-x  $sprite-offset-y;
}

@mixin sprite-image($sprite) {
  $sprite-image: nth($sprite, 9);
  background-image: url(#{$sprite-image});
}

@mixin sprite($sprite) {
  @include sprite-image($sprite);
  @include sprite-position($sprite);
  @include sprite-width($sprite);
  @include sprite-height($sprite);
}

// The `retina-sprite` mixin sets up rules and a media query for a sprite/retina sprite.
//   It should be used with a "retina group" variable.
//
// The media query is from CSS Tricks: https://css-tricks.com/snippets/css/retina-display-media-query/
//
// $icon-home-group: ('icon-home', $icon-home, $icon-home-2x, );
//
// .icon-home {
//   @include retina-sprite($icon-home-group);
// }
@mixin sprite-background-size($sprite) {
  $sprite-total-width: nth($sprite, 7);
  $sprite-total-height: nth($sprite, 8);
  background-size: $sprite-total-width $sprite-total-height;
}

@mixin retina-sprite($retina-group) {
  $normal-sprite: nth($retina-group, 2);
  $retina-sprite: nth($retina-group, 3);
  @include sprite($normal-sprite);

  @media (-webkit-min-device-pixel-ratio: 2),
         (min-resolution: 192dpi) {
    @include sprite-image($retina-sprite);
    @include sprite-background-size($normal-sprite);
  }
}

// The `sprites` mixin generates identical output to the CSS template
//   but can be overridden inside of SCSS
//
// @include sprites($spritesheet-sprites);
@mixin sprites($sprites) {
  @each $sprite in $sprites {
    $sprite-name: nth($sprite, 10);
    .#{$sprite-name} {
      @include sprite($sprite);
    }
  }
}

// The `retina-sprites` mixin generates a CSS rule and media query for retina groups
//   This yields the same output as CSS retina template but can be overridden in SCSS
//
// @include retina-sprites($retina-groups);
@mixin retina-sprites($retina-groups) {
  @each $retina-group in $retina-groups {
    $sprite-name: nth($retina-group, 1);
    .#{$sprite-name} {
      @include retina-sprite($retina-group);
    }
  }
}
